package com.yice.webadmin.app.controller;

import cn.hutool.core.io.FileUtil;
import com.alibaba.fastjson.JSON;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.config.PythonConfig;
import com.yice.webadmin.app.dto.DatasetDetailDto;
import com.yice.webadmin.app.dto.DatasetVersionDto;
import com.yice.webadmin.app.model.DatasetDetail;
import com.yice.webadmin.app.model.DatasetVersion;
import com.yice.webadmin.app.service.DatasetDataService;
import com.yice.webadmin.app.service.DatasetVersionService;
import com.yice.webadmin.app.vo.DatasetVersionVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Optional;

/**
 * 数据集版本操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "数据集版本管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/datasetVersion")
public class DatasetVersionController {

    @Autowired
    private DatasetVersionService datasetVersionService;
    @Autowired
    private PythonConfig pythonConfig;
    @Autowired
    private DatasetDataService datasetDataService;
    /**
     * 新增数据集版本数据。
     *
     * @param datasetVersionDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetVersionDto.versionId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody DatasetVersionDto datasetVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetVersionDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetVersion datasetVersion = MyModelUtil.copyTo(datasetVersionDto, DatasetVersion.class);
        datasetVersion = datasetVersionService.saveNew(datasetVersion);
        return ResponseResult.success(datasetVersion.getVersionId());
    }

    /**
     * 更新数据集版本数据。
     *
     * @param datasetVersionDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody DatasetVersionDto datasetVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetVersionDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetVersion datasetVersion = MyModelUtil.copyTo(datasetVersionDto, DatasetVersion.class);
        DatasetVersion originalDatasetVersion = datasetVersionService.getById(datasetVersion.getVersionId());
        if (originalDatasetVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetVersionService.update(datasetVersion, originalDatasetVersion)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除数据集版本数据。
     *
     * @param versionId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long versionId) {
        if (MyCommonUtil.existBlankArgument(versionId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(versionId);
    }

    /**
     * 列出符合过滤条件的数据集版本列表。
     *
     * @param datasetVersionDtoFilter 过滤对象。
     * @param datasetDetailDtoFilter  一对一从表过滤对象。
     * @param orderParam              排序参数。
     * @param pageParam               分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<DatasetVersionVo>> list(
            @MyRequestBody DatasetVersionDto datasetVersionDtoFilter,
            @MyRequestBody DatasetDetailDto datasetDetailDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetVersion datasetVersionFilter = MyModelUtil.copyTo(datasetVersionDtoFilter, DatasetVersion.class);
        DatasetDetail datasetDetailFilter = MyModelUtil.copyTo(datasetDetailDtoFilter, DatasetDetail.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetVersion.class);
        List<DatasetVersion> datasetVersionList =
                datasetVersionService.getDatasetVersionListWithRelation(datasetVersionFilter, datasetDetailFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetVersionList, DatasetVersion.INSTANCE));
    }

    /**
     * 查看指定数据集版本对象详情。
     *
     * @param versionId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<DatasetVersionVo> view(@RequestParam Long versionId) {
        DatasetVersion datasetVersion = datasetVersionService.getByIdWithRelation(versionId, MyRelationParam.full());
        if (datasetVersion == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetVersionVo datasetVersionVo = DatasetVersion.INSTANCE.fromModel(datasetVersion);
        return ResponseResult.success(datasetVersionVo);
    }


    /**
     * 查看指定数据集最新版本对象详情。
     *
     * @param datasetId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/lastDatasetVersion")
    public ResponseResult<DatasetVersionVo> lastDatasetVersion(@RequestParam Long datasetId) {
        DatasetVersion datasetVersionFilter = new DatasetVersion();
        datasetVersionFilter.setDatasetId(datasetId);
        List<DatasetVersion> datasetVersions = datasetVersionService.getDatasetVersionList(datasetVersionFilter, "dataset_version");
        if (datasetVersions == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetVersion datasetVersion = datasetVersions.get(datasetVersions.size() - 1);
        DatasetVersionVo datasetVersionVo = DatasetVersion.INSTANCE.fromModel(datasetVersion);
        return ResponseResult.success(datasetVersionVo);
    }

    private ResponseResult<Void> doDelete(Long versionId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        DatasetVersion originalDatasetVersion = datasetVersionService.getById(versionId);
        if (originalDatasetVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetVersionService.remove(versionId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        try {
            this.updateJsonFile(pythonConfig.getDatasetFileBaseDir() + pythonConfig.getDatasetInfo(),originalDatasetVersion.getVersionName());
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        //删除文件路径
        FileUtil.del(originalDatasetVersion.getFileUrl());
        //删除数据集
        datasetDataService.delete(versionId);
        return ResponseResult.success();
    }

    private void updateJsonFile(String filePath, String keyToRemove) throws IOException {
        ObjectMapper objectMapper = new ObjectMapper();
        objectMapper.enable(SerializationFeature.INDENT_OUTPUT);
        File jsonFile = new File(filePath);
        // 读取JSON文件
        JsonNode rootNode = objectMapper.readTree(jsonFile);
        // 删除指定键的对象
        if (rootNode.isObject()) {
            ObjectNode objectNode = (ObjectNode) rootNode;
            objectNode.remove(keyToRemove);
        } else {
           log.error("Root node is not an object.");
        }
        // 将更新后的JSON写回文件
        objectMapper.writeValue(jsonFile, rootNode);
    }

    @PostMapping(value = "/detail")
    public ResponseResult<MyPageData<String>> detail(@MyRequestBody Long versionId,
                                                     @MyRequestBody MyPageParam pageParam) throws IOException {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetVersion datasetVersion = this.datasetVersionService.getById(versionId);
        File file = new File(datasetVersion.getFileUrl()); // 指定文件路径
        ObjectMapper objectMapper = new ObjectMapper();
        ArrayNode arrayNode = (ArrayNode) objectMapper.readTree(file); // 读取JSON文件内容并转换为ArrayNode对象
        List<String> dataList = new ArrayList<>();
        for (JsonNode jsonNode : arrayNode) { // 遍历JSON数组并取出每个元素（ObjectNode）中的数据
            dataList.add(jsonNode.toString());
        }
        int total = dataList.size(); // 获取总数据量
        int page = pageParam.getPageNum();
        int limit = pageParam.getPageSize();
        int startIndex = (page - 1) * limit; // 计算起始索引位置
        int endIndex = Math.min(page * limit, total); // 计算结束索引位置（不超出总数据量）
        List<String> pageDataList = dataList.subList(startIndex, endIndex); // 分页处理并取出指定页的数据列表
        return ResponseResult.success(MyPageUtil.makeResponseData(pageDataList, (long) total));
    }

    /**
     * 导入主表数据列表。
     *
     * @param importFile 上传的文件。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.IMPORT)
    @PostMapping("/import")
    public ResponseResult<Void> importFile(
            @RequestParam Long versionId,
            @RequestParam("importFile") MultipartFile importFile) throws IOException {
        String errorMessage;
        if (Objects.isNull(importFile) || importFile.isEmpty()) {
            errorMessage = "数据验证失败，导入文件不能为空！";
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST, errorMessage);
        }
        DatasetVersion datasetVersion = this.datasetVersionService.getById(versionId);
        String versionName = datasetVersion.getVersionName();
        //先存储文件
        String fullName = this.saveDatasetFile(importFile, versionName, versionId);
        //再存储数据集配置文件
        datasetVersionService.saveDatasetInfo(versionName);
        datasetVersion.setFileUrl(fullName);
        datasetVersion.setInputStatus(1);
        datasetVersion.setDataVolume(Long.valueOf(JSON.parseArray(new String(importFile.getBytes(), StandardCharsets.UTF_8)).size()));
        this.datasetVersionService.updateById(datasetVersion);
        return ResponseResult.success();
    }

    /**
     * 保存导入文件。
     *
     * @param importFile 导入的文件。
     * @return 保存的本地文件名。
     */
    private String saveDatasetFile(MultipartFile importFile, String versionName, Long versionId)  throws IOException {
        String fullName = pythonConfig.getDatasetFileBaseDir() + versionName + ".json";
        try {
            byte[] bytes = importFile.getBytes();
            Path path = Paths.get(fullName);
            // 如果没有files文件夹，则创建
            if (!Files.isWritable(path)) {
                Files.createDirectories(Paths.get(pythonConfig.getDatasetFileBaseDir()));
            }
            // 文件写入指定路径
            Files.write(path, bytes);
            // 写入到mongodb中
            datasetVersionService.writeDatasetFileForMongo(bytes,importFile.getOriginalFilename(),versionId);
        } catch (IOException e) {
            log.error("Failed to write imported file [" + importFile.getOriginalFilename() + " ].", e);
            throw e;
        }
        return fullName;
    }

    @GetMapping("/export")
    public ResponseEntity<Resource> export(@RequestParam Long versionId) throws IOException {
        DatasetVersion datasetVersion = this.datasetVersionService.getById(versionId);
        Path file = Paths.get(datasetVersion.getFileUrl()); // 指定本地JSON文件的路径
        Resource resource = new UrlResource(file.toUri()); // 使用UrlResource从文件路径构建一个Resource对象
        Optional<Resource> optionalResource = Optional.ofNullable(resource);
        if (optionalResource.isPresent() && optionalResource.get().exists()) { // 检查文件是否存在
            HttpHeaders headers = new HttpHeaders(); // 构建HTTP响应头
            headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=\"" + resource.getFilename() + "\""); // 设置内容类型为附件，并指定文件名
            headers.setContentType(MediaType.TEXT_PLAIN); // 设置内容类型为JSON
            return ResponseEntity.ok() // 返回200 OK状态码
                    .headers(headers) // 设置响应头
                    .contentLength(resource.contentLength()) // 设置响应内容长度（可选）
                    .body(resource); // 将Resource对象作为响应的主体返回
        } else {
            return ResponseEntity.notFound().build(); // 如果文件不存在，返回404 Not Found状态码
        }
    }
}
